#ifndef _GLOBAL_
#define _GLOBAL_

const double epsilon = 1e-11;
const double PI = 3.141592653589793238462643383279502884197169399375105820974944592308;

//const double constMatrix[4][3] = {{0.75, 0.25, 0}, {0.25, 0.75, 0}, {0, 0.75, 0.25}, {0, 0.25, 0.75}};
//const CMatrix qudraticBsplineMatrix(4, 3, (double **)constMatrix);

const double quadraticMatrix_New[2][2] = {{0.75, 0.25}, {0.25, 0.75}};
const CMatrix qudraticBsplineMatrix_New(2, 2, (const double **)quadraticMatrix_New);

const double cubicMatrix_New[2][3] = {{0.5, 0.5, 0}, {0.125, 0.75, 0.125}};
const CMatrix cubicBsplineMatrix_New(2, 3, (const double **)cubicMatrix_New);

const double BezierMatrix_New[2][3] = {{0.25, 0.5, 0.25}, {0, 0.5, 0.5}};
const CMatrix quadraticBezierMatrix_New(2, 3, (const double **)BezierMatrix_New);

const double BezierMatrix_New_first[3][3] = {{1.0, 0.0, 0.0}, {0.5, 0.5, 0.0}, {0.25, 0.5, 0.25}};
const CMatrix quadraticBezierMatrix_New_first(3, 3, (const double **)BezierMatrix_New_first);

const double BezierMatrix_New_second[3][3] = {{0.25, 0.5, 0.25}, {0.0, 0.5, 0.5}, {0.0, 0.0, 1.0}};
const CMatrix quadraticBezierMatrix_New_second(3, 3, (const double **)BezierMatrix_New_second);


#endif
