#ifndef _CPOINT_
#define _CPOINT_

#include <iostream>

using namespace std;

class CPoint
{
public:
	CPoint (){
		v[0] = 	v[1] = 0;}

	CPoint ( double _x, double _y )  {
		v[0] = _x;
		v[1] = _y;}
	CPoint ( float _x, float _y ) {
		v[0] = _x;
		v[1] = _y;}
	CPoint ( int _x, int _y ) {
		v[0] = _x;
		v[1] = _y;}

	CPoint ( const CPoint& _p )  {
		v[0] = _p.v[0];
		v[1] = _p.v[1];}

	CPoint& operator = ( const CPoint &_p )
	{
		/*if ( this != &_p )
		{
			this->CPoint::~CPoint();
			new (this) CPoint(_p);
		}*/
		v[0] = _p.v[0];
		v[1] = _p.v[1];
		return *this;
	}

	double operator[] (unsigned int i) const 
	{
		//if (i == 0)
		//	return x;
		//else //if (i == 1)
		//	return y;
		return v[i];
	}
	double& operator[] (unsigned int i) 
	{
		//if (i == 0)
		//	return x;
		//else //if (i == 1)
		//	return y;
		return v[i];
	}

	CPoint& operator+= ( const CPoint& pt )
	{
		v[0] += pt.v[0];
		v[1] += pt.v[1];

		return (*this);
	}

	const CPoint& operator*= ( const double s )
	{
		v[0] *= s;
		v[1] *= s;

		return (*this);
	}

	double getX () const { return v[0]; }
	double getY () const { return v[1]; }

	void setX ( double _x ) { v[0] = _x; }
	void setY ( double _y ) { v[1] = _y; }

protected:
	double v[2];
};
/*
class CPoint3 : public CPoint
{
public:
	CPoint3 (): CPoint (), z( 0 ) {}

	CPoint3 ( double _x, double _y ) : CPoint( _x, _y ), z( 0 ) {}
	CPoint3 ( float _x, float _y ) : CPoint( _x, _y ), z( 0 ) {}
	CPoint3 ( int _x, int _y ) : CPoint( _x, _y ), z( 0 ) {}

	CPoint3 ( double _x, double _y, double _z ) : CPoint( _x, _y ), z( _z ) {}
	CPoint3 ( float _x, float _y, float _z ) : CPoint( _x, _y ), z( _z ) {}
	CPoint3 ( int _x, int _y, int _z ) : CPoint( _x, _y ), z( _z ) {}

	CPoint3 ( const CPoint& _p ) : CPoint( _p.getX(), _p.getY() ), z( 0 ) {}
	CPoint3 ( const CPoint3& _p ) : CPoint( _p.getX(), _p.getY() ), z( _p.getZ() ) {}

	CPoint3& operator = ( const CPoint3 &_p )
	{
		if ( this != &_p )
		{
			this->CPoint3::~CPoint3();
			new (this) CPoint3(_p);
		}
		return *this;
	}

	double operator[] (unsigned int i) const 
	{
		if (i == 0)
			return x;
		else if (i == 1)
			return y;
		else //if (i == 2)
			return z;
	}

	CPoint3& operator+= ( const CPoint3& pt )
	{
		x += pt.getX();
		y += pt.getY();
		z += pt.getZ();

		return (*this);
	}

	const CPoint3& operator*= ( const double s )
	{
		x *= s;
		y *= s;
		z *= s;

		return (*this);
	}

	double getZ () const { return z; }

	void setZ ( double _z ) { z = _z; }

private:
	double z;
};

*/
#endif