// Author: Josiah Manson
// Created: 2004
// Description:
// Uses rdtsc instruction to get the number of cpu cycles elapsed in a section of code.
// Multiple sections can be profiled at the same time. The results are then printed
// to a file.

// Modified: March 28, 2005
// A new method of sorting the entries is used. Split into header and source.

#include <string>

using namespace std;

void profilePrint();
void profileBegin(string token);
void profileEnd();
